# Makefile
# 
# Copyright (C) 2002-Present by Ken Zhai <ken_zhai@sdesigns.com>
#
# Name       History
# Ken        Initiated
# 
# 
# Contact Info:
# <ken_zhai@sdesigns.com>
# 
# Sigma Designs
# 1778 McCarthy BLVD
# Milpitas CA 95035, USA
#
EXTRA:=prerequisite
EXTRACLEAN:=$(patsubst %,%-clean,$(EXTRA))
EXTRAINSTALL:=$(patsubst %,%-install,$(EXTRA))
EXTRAUNINSTALL:=$(patsubst %,%-uninstall,$(EXTRA))
EXTRADISTCLEAN:=$(patsubst %,%-distclean,$(EXTRA))
.PHONY: all clean distclean install uninstall $(SUBDIRS)
.PHONY: $(EXTRA) $(EXTRACLEAN) $(EXTRADISTCLEAN) $(EXTRAINSTALL) $(EXTRAUNINSTALL) postrequisite postrequisite-clean postrequisite-distclean
all: $(EXTRA) $(SUBDIRS) postrequisite

clean: $(SUBDIRS) $(EXTRACLEAN) postrequisite-clean

distclean: $(SUBDIRS) $(EXTRADISTCLEAN) postrequisite-distclean

install: $(EXTRAINSTALL) $(SUBDIRS) postrequisite

uninstall: $(SUBDIRS) $(EXTRAUNINSTALL) postrequisite-clean

$(SUBDIRS):
ifeq (install, $(findstring install, $(MAKECMDGOALS)))
	@make $(OPTS) -C $@
endif
	@make $(MAKECMDGOALS) $(OPTS) -C $@
