#
# Name       History
# Ken        Initiated
#
#
# Contact Info:
# <ken_zhai@sdesigns.com>
#
# Sigma Designs
# 1778 McCarthy BLVD
# Milpitas CA 95035, USA
#
############################################################################
#
# oprofile
#
###########################################################################
OPROFILE_VER:=$(strip $(subst ",, $(BR2_OPROFILE_VERSION)))
#"))
ifeq ($(strip $(DOWNLOAD_SITE_PUBLIC)),y)
#OPROFILE_SITE := http://oprofile.sourceforge.net/download
OPROFILE_SITE := $(DOWNLOAD_SITE)
else
OPROFILE_SITE := $(DOWNLOAD_SITE)
endif
OPROFILE_DIR := $(BUILD_DIR)/oprofile-$(OPROFILE_VER)
OPROFILE_SOURCE := oprofile-$(OPROFILE_VER).tar.gz
OPROFILE_UNZIP := gunzip
FAKEROOT_DIR=

$(DL_DIR)/$(OPROFILE_SOURCE):
	@[ -f $@ ] || $(WGET) -P $(@D) $(OPROFILE_SITE)/$(@F)

$(OPROFILE_DIR)/.unpacked: $(DL_DIR)/$(OPROFILE_SOURCE)
	@[ -d $(@D) ] || \
	($(OPROFILE_UNZIP) -c $< | tar -C $(BUILD_DIR) $(TAR_OPTIONS) -)
	@cd $(TOPDIR);$(TOPDIR)/toolchain/patch-kernel.sh $(@D) $(SUBDIR)/$(OPROFILE_VER) oprofile-$(OPROFILE_VER)-\*.patch
	@touch $@

$(OPROFILE_DIR)/.configured: $(OPROFILE_DIR)/.unpacked
	@[  -f $@ ] || \
	(cd $(@D); rm -rf config.cache; ./autogen.sh; \
		CC=$(TARGET_CC) \
                $(TARGET_CONFIGURE_OPTS) \
                $(TARGET_CONFIGURE_ARGS) \
                CFLAGS="-fPIC $(TARGET_CFLAGS) -I$(TOOLCHAIN_INCLUDE_PATH)/include -L$(TOOLCHAIN_LIBS_PATH)/lib" \
                CXXFLAGS="-fPIC $(TARGET_CFLAGS) -I$(TOOLCHAIN_INCLUDE_PATH)/include -L$(TOOLCHAIN_LIBS_PATH)/lib" \
		./configure \
		--target=$(GNU_TARGET_NAME) \
		--host=$(GNU_TARGET_NAME) \
		--build=$(GNU_HOST_NAME) \
		--prefix=$(FAKEROOT_DIR)/usr \
		--exec-prefix=$(FAKEROOT_DIR)/usr \
		--bindir=$(FAKEROOT_DIR)/usr/bin \
		--sbindir=$(FAKEROOT_DIR)/usr/sbin \
		--sysconfdir=$(FAKEROOT_DIR)/etc \
		--datadir=$(ROOTFS_TMP_DIR)/usr/share \
		--localstatedir=$(FAKEROOT_DIR)/var \
		--mandir=$(FAKEROOT_DIR)/usr/man \
		--infodir=$(FAKEROOT_DIR)/usr/info \
		--with-terminfo-dirs=$(FAKEROOT_DIR)/usr/share/terminfo \
		--with-default-terminfo-dir=$(FAKEROOT_DIR)/usr/share/terminfo \
		--libdir=$(ROOTFS_TMP_DIR)/lib \
		--without-shared --without-cxx --without-cxx-binding \
		--without-ada --without-progs $(DISABLE_NLS) \
		--without-profile --without-debug --disable-rpath \
		--enable-echo --enable-const --enable-overwrite \
		--enable-broken_linker --with-kernel-support; \
	touch $@; \
	)

$(OPROFILE_DIR)/daemon/oprofiled: $(OPROFILE_DIR)/.configured
	@[ ! -f $(ROOTFS_LIB)/libbfd.a ] || rm -f $(ROOTFS_LIB)/libbfd.a; \
	[ ! -f $(ROOTFS_LIB)/libpopt.a ] || rm -f $(ROOTFS_LIB)/libpopt.a; \
	[ ! -f $(ROOTFS_LIB)/libintl.a ] || rm -f $(ROOTFS_LIB)/libintl.a; \
	[ ! -f $(ROOTFS_LIB)/oprofile/libopagent.a ] || rm -f $(ROOTFS_LIB)/oprofile/libopagent.a; \
	$(MAKE) BUILD_CC=$(TARGET_CC) HOSTCC=$(HOSTCC) \
		CFLAGS="$(TARGET_CFLAGS)" \
		BUILD_CCFLAGS="-I$(@D)/../include -I$(ROOTFS_INC)" \
		BUILD_CXXFLAGS="-O2 -I$(@D)/../include -I$(ROOTFS_INC)" \
		BUILD_LDFLAGS="-L$(ROOTFS_LIB)" DESTDIR=$(ROOTFS_TMP_DIR) -C $(@D)/..; \
	touch -c $@

$(ROOTFS_TMP_DIR)/bin/oprofiled: $(OPROFILE_DIR)/daemon/oprofiled
	@BUILD_CC=$(TARGET_CC) HOSTCC=$(HOSTCC) CC=$(TARGET_CC) \
	$(MAKE) \
		prefix=$(@D)/.. \
		exec_prefix=$(@D)/.. \
		bindir=$(@D) \
		sbindir=$(@D)/../sbin \
		libexecdir=$(@D)/../lib \
		datadir=$(@D)/../usr/share \
		sysconfdir=$(@D)/../etc \
		localstatedir=$(@D)/../var \
		libdir=$(@D)/../lib \
		infodir=$(@D)/../info \
		mandir=$(@D)/../man \
		includedir=$(@D)/../include \
		-C $(OPROFILE_DIR) install; \
		touch -c $@

$(TARGET_DIR)/lib/libopagent.so: $(OPROFILE_DIR)/libopagent/.libs/libopagent.so.1.0.0
	@[ -d $(@D) ] || mkdir -p $(@D); \
	[ -d $(@D)/../usr/local/lib ] || mkdir -p $(@D)/../usr/local/lib; \
	find $(@D)/../ \( -name "$(@F)*" \) -exec rm -f {} \;; \
	cp -f $< $(@D)/../usr/local/lib; \
	(cd $(@D); ln -s ../usr/local/lib/$(<F) $(<F)); \
	(cd $(@D); ln -s $(<F) $(@F).1; ln -s $(@F).1 $(@F)); \
	touch -c $@
ifeq '$(filter debug,$(COMPILKIND))' ''
	@$(STRIP) --strip-unneeded $(@D)/../usr/local/lib/$(<F)
endif

$(TARGET_DIR)/usr/local/bin/oprofiled: $(ROOTFS_TMP_DIR)/bin/oprofiled
	@[ -d $(@D) ] || mkdir -p $(@D); \
	[ -d $(@D)/../../share/oprofile ] || mkdir -p $(@D)/../../share/oprofile; \
	cp -f $(<D)/op*  $(@D); \
	cp -fr $(<D)/../usr/share/oprofile/mips $(@D)/../../share/oprofile; \
	cp -fr $(<D)/../usr/share/stl.pat $(@D)/../../share/oprofile; \
	chmod +x $(@D)/opcontrol; \
	touch -c $@
ifeq '$(filter debug,$(COMPILKIND))' ''
	@$(STRIP) --strip-unneeded $@ > /dev/null 2>&1; \
	for x in ophelp opreport; \
        do \
        ( \
        [ ! -f $(@D)/$$x ] || $(STRIP) --strip-unneeded $(@D)/$$x > /dev/null 2>&1; \
        ); \
        done; \
	for x in opannotate oparchive opgprof opimport opjitconv; \
	do \
	( \
	[ ! -f $(@D)/$$x ] || rm -f $(@D)/$$x; \
	); \
	done
endif

oprofile: $(TARGET_DIR)/usr/local/bin/oprofiled $(TARGET_DIR)/lib/libopagent.so

oprofile-source: $(DL_DIR)/$(OPROFILE_SOURCE)

.PHONY: oprofile-clean oprofile-uninstall oprofile-install oprofile-dirclean

oprofile-install: oprofile

oprofile-uninstall:
	@[ ! -d  $(OPROFILE_DIR) ] || $(MAKE) -C $(OPROFILE_DIR) uninstall; \
	[ ! -d $(ROOTFS_TMP_DIR)/usr/share/oprofile ] || rm -fr $(ROOTFS_TMP_DIR)/usr/share/oprofile; \
	[ ! -d $(TARGET_DIR)/usr/share/oprofile ] || rm -fr $(TARGET_DIR)/usr/share/oprofile; \
	[ ! -d $(TARGET_DIR)/usr/local/bin ] || find $(TARGET_DIR)/usr/local/bin/ \( -type f -name "op*" \) -exec rm -f {} \;; \
	[ ! -d $(ROOTFS_TMP_DIR)/bin ] || find $(ROOTFS_TMP_DIR)/bin \( -type f -name "op*" \) -exec rm -f {} \;; \
	[ ! -d $(TARGET_DIR)/lib ] || find $(TARGET_DIR)/ \( -name "libo*" \) -exec rm -f {} \;

oprofile-clean: oprofile-uninstall

oprofile-dirclean: oprofile-uninstall
	@-rm -rf $(OPROFILE_DIR)
