/* mytest2.cxx
#
# Sigma Designs
# 1778 McCarthy BLVD
# Milpitas CA 95035, USA
#
*/
#include <iostream>
#include <string>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <time.h>

using namespace std;

#define PRINT 0
/* Default loop counts */
#define DEF_LOOP1_CNT	1000000
#define DEF_LOOP2_CNT	(DEF_LOOP1_CNT * 10)

class myclass
{
       private:
         int x; //Data member 
         int y; //Data member
	 unsigned long long short_cnt, long_cnt;
       public: 
	 myclass();
	 ~myclass();
	unsigned long long loopshort(void);
	unsigned long long looplong(void);
	long assignlong(void);

	void loop_element(void);
	void diff_timeval(struct timeval *tv1, struct timeval *tv2, 
					time_t *sec, suseconds_t *usec);
	int short_loop_func(unsigned long long cnt, time_t *sec, suseconds_t *usec);
	int long_loop_func(unsigned long long cnt, time_t *sec, suseconds_t *usec);
	int loopshort(int argc, char *argv[]);
	int looplong(int argc, char *argv[]);
};	 

myclass::myclass() //Constructor
{
	x = 0;
	y = 0;
	short_cnt = 0;
       	long_cnt = 0;
}

myclass::~myclass() //destructor
{
}

void myclass::loop_element(void)
{
	struct timeval tvx;
	struct timezone tzx;
	int resx;
	if ((resx = gettimeofday(&tvx, &tzx)) != 0) 
		printf("%d: gettimeofday error (%d)\n", __LINE__, resx);
	return;
}

void myclass::diff_timeval(struct timeval *tv1, struct timeval *tv2, 
					time_t *sec, suseconds_t *usec)
{
	*sec = *usec = 0;							
	if (tv2->tv_usec < tv1->tv_usec) {
		*sec = tv2->tv_sec - tv1->tv_sec - 1;
		*usec = (1000000 + tv2->tv_usec) - tv1->tv_usec;
	} else {
		*sec = tv2->tv_sec - tv1->tv_sec;	
		*usec = tv2->tv_usec - tv1->tv_usec;
	}
}

/* Macro to build the loop function */
int myclass::short_loop_func(unsigned long long cnt, time_t *sec, suseconds_t *usec)
{									
	unsigned long long i;							
	struct timeval tv1, tv2;						
	struct timezone tz1, tz2;						
	int res;								
	printf("Running %s with loop count %lld\n", __FUNCTION__, cnt);		
	if ((res = gettimeofday(&tv1, &tz1)) != 0) {				
		printf("%d: gettimeofday error (%d)\n", __LINE__, res);		
		return -1;							
	}									
	for (i = 0; i < cnt; i++) 						
		loop_element();							
	if ((res = gettimeofday(&tv2, &tz2)) != 0) {				
		printf("%d: gettimeofday error (%d)\n", __LINE__, res);		
		return -1;							
	}									
	diff_timeval(&tv1, &tv2, sec, usec);					
	return 0;								
}

/* Macro to build the loop function */
int myclass::long_loop_func(unsigned long long cnt, time_t *sec, suseconds_t *usec)
{									
	unsigned long long i;							
	struct timeval tv1, tv2;						
	struct timezone tz1, tz2;						
	int res;								
	printf("Running %s with loop count %lld\n", __FUNCTION__, cnt);		
	if ((res = gettimeofday(&tv1, &tz1)) != 0) {				
		printf("%d: gettimeofday error (%d)\n", __LINE__, res);		
		return -1;							
	}									
	for (i = 0; i < cnt; i++) 						
		loop_element();							
	if ((res = gettimeofday(&tv2, &tz2)) != 0) {				
		printf("%d: gettimeofday error (%d)\n", __LINE__, res);		
		return -1;							
	}									
	diff_timeval(&tv1, &tv2, sec, usec);					
	return 0;								
}

int myclass::loopshort(int argc, char *argv[])
{
	unsigned long long loopshort_cnt = DEF_LOOP1_CNT;
	unsigned long long looplong_cnt = DEF_LOOP2_CNT;
	time_t sec;
	suseconds_t usec;

	if (argc > 2) 
		goto usage;
	else {
		/* Parsing options (may be overriding default loop counts) */
		switch(argc) {
			case 2: looplong_cnt = DEF_LOOP2_CNT * (unsigned long long)atoll(argv[1]);
			default:
				break;
		}
	}

	/* Start loopshort_func */
	if (short_loop_func(loopshort_cnt, &sec, &usec) == 0)
		printf("Loopshort Elapse: %d.%06d sec\n", sec, usec);
	else {
		printf("Encountered error in loopshort_func.\n");
		goto err_out;
	}

	return 0;

err_out:
	return -1;	

usage:
	printf("usage: %s [number of loop] --- will times 10\n", argv[0]);
	return -1;
}

int myclass::looplong(int argc, char *argv[])
{
	unsigned long long loopshort_cnt = DEF_LOOP1_CNT;
	unsigned long long looplong_cnt = DEF_LOOP2_CNT;
	time_t sec;
	suseconds_t usec;

	if (argc > 2) 
		goto usage;
	else {
		/* Parsing options (may be overriding default loop counts) */
		switch(argc) {
			case 2: looplong_cnt = DEF_LOOP2_CNT * (unsigned long long)atoll(argv[1]);
			default:
				break;
		}
	}

	/* Start looplong_func */
	if (long_loop_func(looplong_cnt, &sec, &usec) == 0)
		printf("Looplong Elapse: %d.%06d sec\n", sec, usec);
	else {
		printf("Encountered error in looplong_func.\n");
		goto err_out;
	}

	return 0;

err_out:
	return -1;	

usage:
	printf("usage: %s [number of loop] --- will times 10\n", argv[0]);
	return -1;
}


unsigned long long myclass::loopshort(void) 
{ 
        long i,j; 
        for (j=0; j<1; j++) {
        for (i=0; i<12345678; i++) short_cnt++;
        }
         return short_cnt;
}

unsigned long long myclass::looplong(void) 
{ 
        unsigned long i,j; 
        for (j=0; j<1000; j++) {
        for (i=0; i<0x12345678; i++) long_cnt++;
        for (i=0; i<0x12345678; i++) long_cnt++;
        for (i=0; i<0x12345678; i++) long_cnt++;
        for (i=0; i<0x12345678; i++) long_cnt++;
        }
        return long_cnt;
}

long myclass::assignlong(void) 
{ 
	long k;
        k=0x12345678;	
        return k;
}

class SB    //With copy constructor
{
           private:
           char *name;
           public:
           SB();
           ~SB();
     //Copy constructor
           SB(const SB &b);
};

SB::SB()
{
   name = new char[200];
}

SB::~SB()
{
//   delete name[];
   delete name;
}

SB::SB(const SB &b)
{
	name = new char[200];
	//strcpy(name, b.name);
}

struct A {
  int i;
  A() : i(10) {
    if (PRINT) cout << "Constructor A(), i = " << i << endl;
  }
};

struct B {
  int j;
  B() : j(20) {
   if (PRINT)  cout << "Constructor B(), j = " << j << endl;
  }

  B(B& arg) : j(arg.j) {
   if (PRINT)  cout << "Copy constructor B(B&), j = " << j << endl;
  }

  B(const B&, int val = 30) : j(val) {
   if (PRINT)  cout << "Copy constructor B(const B&, int), j = " << j << endl;
  }
};

struct CopyConstructor : public myclass {

  int * pd;
  string id;

  CopyConstructor()  {
    pd = new int(0);
    id = "Copy Constructed";
  };
  
  CopyConstructor(CopyConstructor & ref) {
    if (PRINT)  cout << "Copy Constructor called" << endl;
    pd = new int (*ref.pd) ;
    id = "Copy Constructed";
  };

  CopyConstructor(string name) {
    pd = new int(0) ;
    id=name;
    if (PRINT)  cout << "Constructor for " << id << endl;
  };

  ~CopyConstructor() {
    if (PRINT)  cout << "Destructor for " << id << endl;
    delete pd;
  };

  int short_copy_func(unsigned long long cnt, time_t *sec, suseconds_t *usec);
  int long_copy_func(unsigned long long cnt, time_t *sec, suseconds_t *usec);
  int copyshort(int argc, char *argv[]);
  int copylong(int argc, char *argv[]);
};

/* Macro to build the loop function */
int CopyConstructor::short_copy_func(unsigned long long cnt, time_t *sec, suseconds_t *usec)
{									
	unsigned long long i;							
	struct timeval tv1, tv2;						
	struct timezone tz1, tz2;						
	int res;								
	printf("Running %s with loop count %lld\n", __FUNCTION__, cnt);		
	if ((res = gettimeofday(&tv1, &tz1)) != 0) {				
		printf("%d: gettimeofday error (%d)\n", __LINE__, res);		
		return -1;							
	}									
	for (i = 0; i < cnt; i++) {
#if 1		
		  CopyConstructor mystring1("long") ;
		  *mystring1.pd =1000;
		  CopyConstructor mystring2=mystring1;
#else
		  loop_element();	
#endif				
	}
	if ((res = gettimeofday(&tv2, &tz2)) != 0) {				
		printf("%d: gettimeofday error (%d)\n", __LINE__, res);		
		return -1;							
	}									
	diff_timeval(&tv1, &tv2, sec, usec);					
	return 0;								
}

/* Macro to build the loop function */
int CopyConstructor::long_copy_func(unsigned long long cnt, time_t *sec, suseconds_t *usec)
{									
	unsigned long long i;							
	struct timeval tv1, tv2;						
	struct timezone tz1, tz2;						
	int res;								
	printf("Running %s with loop count %lld\n", __FUNCTION__, cnt);		
	if ((res = gettimeofday(&tv1, &tz1)) != 0) {				
		printf("%d: gettimeofday error (%d)\n", __LINE__, res);		
		return -1;							
	}									
	for (i = 0; i < cnt; i++) {
#if 1		
		  CopyConstructor mystring1("long") ;
		  *mystring1.pd =1000;
		  CopyConstructor mystring2=mystring1;
#else
		  loop_element();	
#endif		  
	}
	if ((res = gettimeofday(&tv2, &tz2)) != 0) {				
		printf("%d: gettimeofday error (%d)\n", __LINE__, res);		
		return -1;							
	}									
	diff_timeval(&tv1, &tv2, sec, usec);					
	return 0;								
}

int CopyConstructor::copyshort(int argc, char *argv[])
{
	unsigned long long loopshort_cnt = DEF_LOOP1_CNT;
	unsigned long long looplong_cnt = DEF_LOOP2_CNT;
	time_t sec;
	suseconds_t usec;

	if (argc > 2) 
		goto usage;
	else {
		/* Parsing options (may be overriding default loop counts) */
		switch(argc) {
			case 2: looplong_cnt = DEF_LOOP2_CNT * (unsigned long long)atoll(argv[1]);
			default:
				break;
		}
	}

	/* Start short_copy_func */
	if (short_copy_func(loopshort_cnt, &sec, &usec) == 0)
		printf("Copyshort Elapse: %d.%06d sec\n", sec, usec);
	else {
		printf("Encountered error in loopshort_func.\n");
		goto err_out;
	}

	return 0;

err_out:
	return -1;	

usage:
	printf("usage: %s [number of loop] --- will times 10\n", argv[0]);
	return -1;
}

int CopyConstructor::copylong(int argc, char *argv[])
{
	unsigned long long loopshort_cnt = DEF_LOOP1_CNT;
	unsigned long long looplong_cnt = DEF_LOOP2_CNT;
	time_t sec;
	suseconds_t usec;

	if (argc > 2) 
		goto usage;
	else {
		/* Parsing options (may be overriding default loop counts) */
		switch(argc) {
			case 2: looplong_cnt = DEF_LOOP2_CNT * (unsigned long long)atoll(argv[1]);
			default:
				break;
		}
	}

	/* Start long_copy_func */
	if (long_copy_func(looplong_cnt, &sec, &usec) == 0)
		printf("Copylong Elapse: %d.%06d sec\n", sec, usec);
	else {
		printf("Encountered error in loopshort_func.\n");
		goto err_out;
	}

	return 0;
err_out:
	return -1;	
usage:
	printf("usage: %s [number of loop] --- will times 10\n", argv[0]);
	return -1;
}

int main(int argc, char *argv[])
{
#ifndef NO_BATCH_TEST
	myclass looptest;
	looptest.loopshort(argc, argv);
        looptest.looplong(argc, argv);
#else
	myclass looptest;
	CopyConstructor copytest;
	int fork_rv;
	fork_rv = fork();
	if(fork_rv == -1)
	  perror("fork");
	else if (fork_rv == 0) {
	        cout << "the child1 pid:" << getpid() << endl;
		looptest.loopshort(argc, argv);
		exit(1);
  	}
	else {
		if (fork() == 0) {
 	           cout << "the child2 pid:" << getpid() << endl;
		   looptest.looplong(argc, argv);
		   exit(2);
  	        } 
#ifndef NO_COPY_CONSTRUCTOR
		if (fork() == 0) {
 	           cout << "the child3 pid:" << getpid() << endl;
		   copytest.copyshort(argc, argv);
		   exit(3);
  	        } 
		
		if (fork() == 0) {
 	           cout << "the child4 pid:" << getpid() << endl;
		   copytest.copylong(argc, argv);
		   exit(4);
  	        } 
#endif
 	        cout << "the parent pid:" << getpid() << endl;
	}
#endif		
	return 0;
}
