#!/bin/bash
#
# <ken_zhai@sdesigns.com>
# Sigma Designs
# 1778 McCarthy BLVD
# Milpitas CA 95035, USA
#
if [ $# = 0 ]; then
LIMIT=10
else
LIMIT=$1
fi

LOG_FILE=/mnt/test.log

echo "This is my $LIMIT test results" > $LOG_FILE

function reset_oprofile() {
opcontrol --vmlinux=/mnt/vmlinux
[ ! -d /var/lib/oprofile/sample ] || rm -fr /var/lib/oprofile/sample
opcontrol --reset
opcontrol --start
}

for ((a=1; a <= LIMIT ; a++))  # Double parentheses, and "LIMIT" with no "$".
do
        reset_oprofile
        echo "*******************Test $a Start***********************************" >> $LOG_FILE
	/bin/mytest2 $a >> $LOG_FILE
	opcontrol --dump && opreport --exclude-dependent --demangle=smart --symbols `which mytest2` >> $LOG_FILE
        opcontrol --reset
        echo "" >> $LOG_FILE
        echo -n "$a"
done                           # A construct borrowed from 'ksh93'.

echo; echo
