#
# Makefile
#
# Name       History
# Ken        Initiated
# 
# Contact Info:
# <ken_zhai@sdesigns.com>
#
# Sigma Designs
# 1778 McCarthy BLVD
# Milpitas CA 95035, USA
#
#CFLAGS += -O3
#CFLAGS += -g
#CFLAGS += -static
#CFLAGS += -Os -pipe
#CFLAGS += -fPIC
#CFLAGS += -Werror

VPATH:=.
FILES:=$(wildcard *.h *.cxx *.c)
SRC_H := $(filter %.h,$(FILES))
SRC_C := $(filter %.c,$(FILES))
SRC_CXX2 := $(filter %.cxx,$(FILES))
C_OBJS := $(patsubst %.c,%.o,$(SRC_C))

ifndef INTEL
PATH=$(TARGET_PATH)
AR=$(TARGET_CROSS)ar
AS=$(TARGET_CROSS)as
LD=$(TARGET_CROSS)ld
NM=$(TARGET_CROSS)nm
CC=$(TARGET_CROSS)gcc
GCC=$(TARGET_CROSS)gcc
CXX=$(TARGET_CROSS)g++
RANLIB=$(TARGET_CROSS)ranlib
CFLAGS:=$(subst -O2,-O0,$(TARGET_CFLAGS))
CFLAGS:=$(subst -O3,-O0,$(CFLAGS))
CFLAGS:=$(subst -g,,$(CFLAGS))
CFLAGS+=-g
CXXFLAGS:=$(CFLAGS)
else
CROSS:=
CC := $(CROSS)gcc
CXX := $(CROSS)g++
STRIP := $(CROSS)strip
endif

TARGETS := mytest1 mytest2

.PHONY:  op_test op_test-clean op_test-install op_test-uninstall op_test-dirtclean
op_test: $(TARGETS) $(TARGET_DIR)/bin/op_test.bash

op_test-clean:
	@$(RM) -f $(TARGETS) *.o *~

op_test-install: op_test
$(TARGET_DIR)/bin/op_test.bash:
	@mkdir -p $(@D)
	@cp -f $(TARGETS) $(@F) $(@D)
	@touch -c $@

op_test-uninstall:
	@cd $(TARGET_DIR)/bin; rm -f $(TARGETS) 
	@-rm -f $(TARGET_DIR)/bin/op_test.bash

op_test-dirclean: op_test-uninstall op_test-clean

mytest2: $($@.cxx) 
	$(CXX) $(CXXFLAGS) -o $@ $(SRC_CXX2)

mytest1: $(C_OBJS)
%.o: %.c $(SRC_H)
