#!/bin/bash

if [ "$1" = "" ]; then
	echo "usage: $0 src_dir install_dir"
	exit 1
fi

if [ ! -d "$1" ]; then
	echo "usage: $0 src_dir install_dir"
	exit 1
fi

if [ ! -d "$2" ]; then
	echo "usage: $0 src_dir install_dir"
	exit 1
fi

ALL_LIST="c++ cpp g++ gcc"
EL_LIST="ld"
INC_LIST="as"
PASS_LIST="addr2line ar c++filt gcov gdb gdbtui gprof nm objcopy objdump ranlib readelf size strings strip"

cp -f $1/mipsel-linux-* $2

pushd $2

#for i in $ALL_LIST
#do
#	ln -sf mipsel-linux-ALL mips-linux-gnu-$i
#done

for i in $ALL_LIST
do
	ln -sf mipsel-linux-ALL mipsel-linux-$i
done

for i in $EL_LIST
do
	ln -sf mipsel-linux-EL mipsel-linux-$i
done

for i in $INC_LIST
do
	ln -sf mipsel-linux-INC mipsel-linux-$i
done

for i in $PASS_LIST
do
	ln -sf mipsel-linux-PASS mipsel-linux-$i
done

for i in $ALL_LIST $EL_LIST $INC_LIST $PASS_LIST
do
	ln -sf mipsel-linux-$i mipsel-linux-uclibc-$i
done

popd

exit 

