####################################################################################################
#
# Any custom stuff you feel like doing....
#
####################################################################################################
.PHONY: customize-clean customize-install customize-uninstall customize-distclean
customize-install: customize
customize-clean customize-uninstall:
	@-rm -f $(custom_installed_file_list)

customize-dirclean: customize-clean
	
CUST_DIR:=$(BASE_DIR)/toolchain/customize/source

custom_file_list := $(shell find $(CUST_DIR) -not '(' -type d -name CVS -prune ')' -type f)

custom_installed_file_list := $(custom_file_list:$(CUST_DIR)/%=$(TARGET_DIR)/%)

$(custom_installed_file_list): $(TARGET_DIR)/%: $(CUST_DIR)/% FORCE
	@if [ ! -d $(@D) ]; then echo mkdir -p $(@D); mkdir -p $(@D); fi; \
	cp -df --preserve=mode --preserve=ownership $< $@
FORCE:
customize: $(custom_installed_file_list)
ifeq '$(filter hardfloat,$(COMPILKIND))' ''
	@cp -f $(SMP86XX_TOOLCHAIN_PATH)/mips-linux-gnu/libc/soft-float/el/usr/bin/ldd $(TARGET_DIR)/bin
	@mkdir -p $(TARGET_DIR)/usr/share/zoneinfo
	@cp -f $(SMP86XX_TOOLCHAIN_PATH)/mips-linux-gnu/libc/soft-float/el/usr/share/zoneinfo/PST8PDT $(TARGET_DIR)/usr/share/zoneinfo
	@cp -f $(SMP86XX_TOOLCHAIN_PATH)/mips-linux-gnu/libc/soft-float/el/usr/share/zoneinfo/MST7MDT $(TARGET_DIR)/usr/share/zoneinfo
	@cp -f $(SMP86XX_TOOLCHAIN_PATH)/mips-linux-gnu/libc/soft-float/el/usr/share/zoneinfo/CST6CDT $(TARGET_DIR)/usr/share/zoneinfo
	@cp -f $(SMP86XX_TOOLCHAIN_PATH)/mips-linux-gnu/libc/soft-float/el/usr/share/zoneinfo/EST5EDT $(TARGET_DIR)/usr/share/zoneinfo
else
	@cp -f $(SMP86XX_TOOLCHAIN_PATH)/mips-linux-gnu/libc/el/usr/bin/ldd $(TARGET_DIR)/bin
	@mkdir -p $(TARGET_DIR)/usr/share/zoneinfo
	@cp -f $(SMP86XX_TOOLCHAIN_PATH)/mips-linux-gnu/libc/el/usr/share/zoneinfo/PST8PDT $(TARGET_DIR)/usr/share/zoneinfo
	@cp -f $(SMP86XX_TOOLCHAIN_PATH)/mips-linux-gnu/libc/el/usr/share/zoneinfo/MST7MDT $(TARGET_DIR)/usr/share/zoneinfo
	@cp -f $(SMP86XX_TOOLCHAIN_PATH)/mips-linux-gnu/libc/el/usr/share/zoneinfo/CST6CDT $(TARGET_DIR)/usr/share/zoneinfo
	@cp -f $(SMP86XX_TOOLCHAIN_PATH)/mips-linux-gnu/libc/el/usr/share/zoneinfo/EST5EDT $(TARGET_DIR)/usr/share/zoneinfo
endif
	@gzip -c9 $(BASE_DIR)/.config > $(TARGET_DIR)/etc/cs_rootfs_config.gz
	@ln -sf $(BASE_DIR) $(TARGET_DIR)/etc/cs_rootfs_source
