ifndef RUNTIME_LIBS_MK
RUNTIME_LIBS_MK := 1

ifeq '$(filter glibc,$(COMPILKIND))' ''
ifeq '$(filter hardfloat,$(COMPILKIND))' ''
RUNTIME_LIBS_PATH := $(SMP86XX_TOOLCHAIN_PATH)/mips-linux-gnu/libc/uclibc/soft-float/el
else
RUNTIME_LIBS_PATH := $(SMP86XX_TOOLCHAIN_PATH)/mips-linux-gnu/libc/uclibc/el
endif
else
ifeq '$(filter hardfloat,$(COMPILKIND))' ''
RUNTIME_LIBS_PATH := $(SMP86XX_TOOLCHAIN_PATH)/mips-linux-gnu/libc/soft-float/el
else
RUNTIME_LIBS_PATH := $(SMP86XX_TOOLCHAIN_PATH)/mips-linux-gnu/libc/el
endif
endif

rtlib_list_all := $(shell ls $(RUNTIME_LIBS_PATH)/lib/*.so $(RUNTIME_LIBS_PATH)/lib/*.so.* $(RUNTIME_LIBS_PATH)/usr/lib/libstd*.so $(RUNTIME_LIBS_PATH)/usr/lib/libstd*.so.* )

rtlib_list := $(shell for f in $(rtlib_list_all); do basename $$f; done)
 
toolchain_rtlib_list := $(rtlib_list_all)
target_rtlib_list := $(rtlib_list:%=$(TARGET_DIR)/lib/%)

.PHONY: echo-rtlib-debug
echo-rtlib-debug:
	@echo toolchain_rtlib_list = $(toolchain_rtlib_list)
	@echo target_rtlib_list = $(target_rtlib_list)

$(target_rtlib_list): $(toolchain_rtlib_list)
	@[ -d  $(TARGET_DIR)/lib ] || mkdir -p $(TARGET_DIR)/lib
	@cp -fa $^ $(TARGET_DIR)/lib
ifeq '$(filter debug,$(COMPILKIND))' ''
	@$(STRIP) $(target_rtlib_list)
endif

.PHONY: install-runtime-libs
install-runtime-libs: $(target_rtlib_list) 
endif
